---
title: Add a Modal Editor to the Property Grid
product: Survey Creator
description: Learn how to enhance your survey elements by adding a modal editor to the Property Grid of your fully integrated form builder. This demo demonstrates how to implement a custom property editor that enables survey authors to manage access rules for a selected question within a pop-up dialog. View a free demo example for JavaScript to learn more.
framework: Vanilla JS
source: https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/vanillajs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Add a Modal Editor to the Property Grid (Vanilla JS)

Survey elements come with a variety of built-in properties that cover most use cases. If you want to extend the available functionality, you can [add custom properties](/survey-creator/examples/add-properties-to-property-grid/) to survey elements and [implement custom property editors](/survey-creator/examples/customize-property-editors/). This example demonstrates a custom editor that allows survey authors to configure properties in a pop-up dialog. To open the dialog, click the Set Access Rules button. The dialog features a dynamic table where you can add or remove access rules for the selected question.

Follow the steps below to configure a modal property editor for a custom property:

1. Add a custom property to a question type.            
Call the `addProperty(className, propMeta)` method on the `Serializer` object. `className` is the name of a base or derived class (see the [`getType()`](https://surveyjs.io/form-library/documentation/api-reference/question#getType) method description); `propMeta` is a JSON object with [property settings](https://surveyjs.io/form-library/documentation/customize-question-types/add-custom-properties-to-a-form#survey-element-property-settings).

1. Add an editor for the custom property.           
Register the property editor in the `PropertyGridEditorCollection` and specify a standard JSON object that the custom type should produce. For instance, in this demo, the custom editor is a Dynamic Matrix. 

1. Define a survey JSON schema for the modal dialog.            
The modal dialog is built upon a regular SurveyJS survey. To specify the dialog's content, configure a survey JSON schema and use it to instantiate a [`SurveyModel`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model) object.

1. Add a button that opens the dialog to the editor title.          
Implement an [`onPropertyEditorUpdateTitleActions`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#onPropertyEditorUpdateTitleActions) event handler. Within it, check that the event is raised for a required property and add an [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) configuration object to the `options.titleActions` array. This configuration object should include the [`action`](https://surveyjs.io/form-library/documentation/api-reference/iaction#action) function.

1. Open the dialog on a button click.         
Call the global `showDialog` method within the `action` function to open the custom dialog when users click the button. Use the method's parameters to specify a `SurveyModel` instance that represents the dialog's content and define handling functions for the Apply and Cancel buttons. When a user clicks Apply, retrieve values from the pop-up survey using its `data` property and assign them to the current question. Refer to the code listing for details.

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/index.css`

```css
.sv-property-editor .sd-root-modern {
    min-width: 640px;
}
```

### `src/index.js`

```js
import { SurveyCreator } from "survey-creator-js";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { SurveyModel, Serializer, settings } from "survey-core";
import { PropertyGridEditorCollection, getLocaleStrings } from "survey-creator-core";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";
import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

// Step 1: Add a custom property to a question type
Serializer.addProperty("question", {
  name: "accessRules",
  type: "accessrules",
  category: "accessRules",
  showValueInLink: false
});

// Step 2: Add an editor for the custom property
PropertyGridEditorCollection.register({
  fit: (prop) => prop.type === "accessrules",
  getJSON: () => {
    return {
      "type": "matrixdynamic",
      "rowCount": 0,
      "allowRemoveRows": false,
      "columns": [
        {
          "name": "userRole",
          "title": "User Role",
          "cellType": "dropdown",
          "readOnly": true,
          "isRequired": true,
          "choices": [
            { "value": "admin", "text": "Admin" },
            { "value": "editor", "text": "Editor" },
            { "value": "viewer", "text": "Viewer" },
            { "value": "guest", "text": "Guest" }
          ]
        },
        {
          "name": "permissions",
          "title": "Permissions",
          "cellType": "dropdown",
          "readOnly": true,
          "choices": [
            { "value": "view", "text": "View" },
            { "value": "edit", "text": "Edit" }
          ],
          "showNoneItem": true,
          "noneText": "No access"
        }
      ]
    }
  }
});

const translation = getLocaleStrings("en");
translation.pe.tabs.accessRules = "Access Rules";
translation.pehelp.accessRules = "Specify user roles that can interact with the selected form element and define their permissions.";

const creator = new SurveyCreator();

// Step 3: Define a survey JSON schema for the modal dialog
const popupJson = {
  "elements": [
    {
      "type": "matrixdynamic",
      "name": "accessRules",
      "titleLocation": "hidden",
      "columns": [
        {
          "name": "userRole",
          "title": "User Role",
          "isRequired": true,
          "cellType": "dropdown",
          "isUnique": true,
          "choices": [
            { "value": "admin", "text": "Admin" },
            { "value": "editor", "text": "Editor" },
            { "value": "viewer", "text": "Viewer" },
            { "value": "guest", "text": "Guest" }
          ]
        },
        {
          "name": "permissions",
          "title": "Permissions",
          "cellType": "dropdown",
          "defaultValue": "Edit",
          "choices": [
            { "value": "view", "text": "View" },
            { "value": "edit", "text": "Edit" }
          ],
          "showNoneItem": true,
          "noneText": "No access"
        }
      ],
      "rowCount": 0,
      "maxRowCount": 4,
      "addRowText": "Add Access Rule"
    }
  ],
  "showNavigationButtons": false
};

const popupSurvey = new SurveyModel(popupJson);

// Step 4: Add a button that opens the dialog to the editor title
creator.onPropertyEditorUpdateTitleActions.add((_, options) => {
  if (options.property.name === "accessRules") {
    popupSurvey.setValue("accessRules", options.element.accessRules);
    options.titleActions.push({
      id: "setAccessRules",
      title: "Set Access Rules",
      // Step 5: Open the dialog on a button click
      action: () => {
        settings.showDialog({
          componentName: "survey",
          data: { model: popupSurvey },
          onApply: () => {
            const validAccessRules = popupSurvey.validate();
            if (validAccessRules) {
              // Get values from the pop-up survey using its `data` property
              // and update the current question (`options.element`)
              options.element.setPropertyValue("accessRules", popupSurvey.data["accessRules"]);
              return true;
            }
            return false;
          },
          onCancel: () => {
            console.log("Cancel");
          },
          cssClass: "sv-property-editor",
          title: "Configure Access Rules for " + options.element.title,
          displayMode: "popup"
        }, creator.rootElement)
      }
    });
  }
});

creator.JSON = {
  "pages": [
    {
      "name": "page1",
      "elements": [
        {
          "type": "text",
          "name": "userName",
          "title": "User Name",
          "accessRules": [
            { "userRole": "admin", "permissions": "edit" },
            { "userRole": "viewer", "permissions": "view" },
            { "userRole": "guest", "permissions": "none" }
          ]
        },
        {
          "type": "text",
          "name": "dob",
          "title": "Date of Birth",
          "maskType": "datetime",
          "maskSettings": {
            "pattern": "m-dd-yyyy"
          }
        }
      ]
    }
  ]
}

creator.showSidebar = true;
creator.selectedElement = creator.survey.getQuestionByName("userName");
creator.expandPropertyGridCategory("accessRules");
creator.render("surveyCreatorContainer");
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-js": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/angular.md)
- [React](https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/jquery.md)


---
title: Add a Modal Editor to the Property Grid
product: Survey Creator
description: Learn how to enhance your survey elements by adding a modal editor to the Property Grid of your fully integrated form builder. This demo demonstrates how to implement a custom property editor that enables survey authors to manage access rules for a selected question within a pop-up dialog. View a free demo example for JavaScript to learn more.
framework: React
source: https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/reactjs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Add a Modal Editor to the Property Grid (React)

Survey elements come with a variety of built-in properties that cover most use cases. If you want to extend the available functionality, you can [add custom properties](/survey-creator/examples/add-properties-to-property-grid/) to survey elements and [implement custom property editors](/survey-creator/examples/customize-property-editors/). This example demonstrates a custom editor that allows survey authors to configure properties in a pop-up dialog. To open the dialog, click the Set Access Rules button. The dialog features a dynamic table where you can add or remove access rules for the selected question.

Follow the steps below to configure a modal property editor for a custom property:

1. Add a custom property to a question type.            
Call the `addProperty(className, propMeta)` method on the `Serializer` object. `className` is the name of a base or derived class (see the [`getType()`](https://surveyjs.io/form-library/documentation/api-reference/question#getType) method description); `propMeta` is a JSON object with [property settings](https://surveyjs.io/form-library/documentation/customize-question-types/add-custom-properties-to-a-form#survey-element-property-settings).

1. Add an editor for the custom property.           
Register the property editor in the `PropertyGridEditorCollection` and specify a standard JSON object that the custom type should produce. For instance, in this demo, the custom editor is a Dynamic Matrix. 

1. Define a survey JSON schema for the modal dialog.            
The modal dialog is built upon a regular SurveyJS survey. To specify the dialog's content, configure a survey JSON schema and use it to instantiate a [`SurveyModel`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model) object.

1. Add a button that opens the dialog to the editor title.          
Implement an [`onPropertyEditorUpdateTitleActions`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#onPropertyEditorUpdateTitleActions) event handler. Within it, check that the event is raised for a required property and add an [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) configuration object to the `options.titleActions` array. This configuration object should include the [`action`](https://surveyjs.io/form-library/documentation/api-reference/iaction#action) function.

1. Open the dialog on a button click.         
Call the global `showDialog` method within the `action` function to open the custom dialog when users click the button. Use the method's parameters to specify a `SurveyModel` instance that represents the dialog's content and define handling functions for the Apply and Cancel buttons. When a user clicks Apply, retrieve values from the pop-up survey using its `data` property and assign them to the current question. Refer to the code listing for details.

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/SurveyCreatorComponent.jsx`

```js
import React from "react";
import { SurveyCreator, SurveyCreatorComponent } from "survey-creator-react";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { SurveyModel, Serializer, settings } from "survey-core";
import { PropertyGridEditorCollection, getLocaleStrings } from "survey-creator-core";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

// Step 1: Add a custom property to a question type
Serializer.addProperty("question", {
  name: "accessRules",
  type: "accessrules",
  category: "accessRules",
  showValueInLink: false
});

// Step 2: Add an editor for the custom property
PropertyGridEditorCollection.register({
  fit: (prop) => prop.type === "accessrules",
  getJSON: () => {
    return {
      "type": "matrixdynamic",
      "rowCount": 0,
      "allowRemoveRows": false,
      "columns": [
        {
          "name": "userRole",
          "title": "User Role",
          "cellType": "dropdown",
          "readOnly": true,
          "isRequired": true,
          "choices": [
            { "value": "admin", "text": "Admin" },
            { "value": "editor", "text": "Editor" },
            { "value": "viewer", "text": "Viewer" },
            { "value": "guest", "text": "Guest" }
          ]
        },
        {
          "name": "permissions",
          "title": "Permissions",
          "cellType": "dropdown",
          "readOnly": true,
          "choices": [
            { "value": "view", "text": "View" },
            { "value": "edit", "text": "Edit" }
          ],
          "showNoneItem": true,
          "noneText": "No access"
        }
      ]
    }
  }
});

const translation = getLocaleStrings("en");
translation.pe.tabs.accessRules = "Access Rules";
translation.pehelp.accessRules = "Specify user roles that can interact with the selected form element and define their permissions.";

function SurveyCreatorRenderComponent() {
    const creator = new SurveyCreator();
    // Step 3: Define a survey JSON schema for the modal dialog
    const popupJson = {
      "elements": [
        {
          "type": "matrixdynamic",
          "name": "accessRules",
          "titleLocation": "hidden",
          "columns": [
            {
              "name": "userRole",
              "title": "User Role",
              "isRequired": true,
              "cellType": "dropdown",
              "isUnique": true,
              "choices": [
                { "value": "admin", "text": "Admin" },
                { "value": "editor", "text": "Editor" },
                { "value": "viewer", "text": "Viewer" },
                { "value": "guest", "text": "Guest" }
              ]
            },
            {
              "name": "permissions",
              "title": "Permissions",
              "cellType": "dropdown",
              "defaultValue": "Edit",
              "choices": [
                { "value": "view", "text": "View" },
                { "value": "edit", "text": "Edit" }
              ],
              "showNoneItem": true,
              "noneText": "No access"
            }
          ],
          "rowCount": 0,
          "maxRowCount": 4,
          "addRowText": "Add Access Rule"
        }
      ],
      "showNavigationButtons": false
    };
    
    const popupSurvey = new SurveyModel(popupJson);
    
    // Step 4: Add a button that opens the dialog to the editor title
    creator.onPropertyEditorUpdateTitleActions.add((_, options) => {
      if (options.property.name === "accessRules") {
        popupSurvey.setValue("accessRules", options.element.accessRules);
        options.titleActions.push({
          id: "setAccessRules",
          title: "Set Access Rules",
          // Step 5: Open the dialog on a button click
          action: () => {
            settings.showDialog({
              componentName: "survey",
              data: { model: popupSurvey },
              onApply: () => {
                const validAccessRules = popupSurvey.validate();
                if (validAccessRules) {
                  // Get values from the pop-up survey using its `data` property
                  // and update the current question (`options.element`)
                  options.element.setPropertyValue("accessRules", popupSurvey.data["accessRules"]);
                  return true;
                }
                return false;
              },
              onCancel: () => {
                console.log("Cancel");
              },
              cssClass: "sv-property-editor",
              title: "Configure Access Rules for " + options.element.title,
              displayMode: "popup"
            }, creator.rootElement)
          }
        });
      }
    });
    
    creator.JSON = {
      "pages": [
        {
          "name": "page1",
          "elements": [
            {
              "type": "text",
              "name": "userName",
              "title": "User Name",
              "accessRules": [
                { "userRole": "admin", "permissions": "edit" },
                { "userRole": "viewer", "permissions": "view" },
                { "userRole": "guest", "permissions": "none" }
              ]
            },
            {
              "type": "text",
              "name": "dob",
              "title": "Date of Birth",
              "maskType": "datetime",
              "maskSettings": {
                "pattern": "m-dd-yyyy"
              }
            }
          ]
        }
      ]
    }
    
    creator.showSidebar = true;
    creator.selectedElement = creator.survey.getQuestionByName("userName");
    creator.expandPropertyGridCategory("accessRules");
    return (<SurveyCreatorComponent creator={creator} />);
}

export default SurveyCreatorRenderComponent;
```

### `src/index.css`

```css
.sv-property-editor .sd-root-modern {
    min-width: 640px;
}
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyCreatorRenderComponent from "./SurveyCreatorComponent";

const root = createRoot(document.getElementById("surveyCreatorContainer"));
root.render(<SurveyCreatorRenderComponent />);
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-react": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/angular.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/vanillajs.md)


---
title: Add a Modal Editor to the Property Grid
product: Survey Creator
description: Learn how to enhance your survey elements by adding a modal editor to the Property Grid of your fully integrated form builder. This demo demonstrates how to implement a custom property editor that enables survey authors to manage access rules for a selected question within a pop-up dialog. View a free demo example for JavaScript to learn more.
framework: Angular
source: https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/angular
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Add a Modal Editor to the Property Grid (Angular)

Survey elements come with a variety of built-in properties that cover most use cases. If you want to extend the available functionality, you can [add custom properties](/survey-creator/examples/add-properties-to-property-grid/) to survey elements and [implement custom property editors](/survey-creator/examples/customize-property-editors/). This example demonstrates a custom editor that allows survey authors to configure properties in a pop-up dialog. To open the dialog, click the Set Access Rules button. The dialog features a dynamic table where you can add or remove access rules for the selected question.

Follow the steps below to configure a modal property editor for a custom property:

1. Add a custom property to a question type.            
Call the `addProperty(className, propMeta)` method on the `Serializer` object. `className` is the name of a base or derived class (see the [`getType()`](https://surveyjs.io/form-library/documentation/api-reference/question#getType) method description); `propMeta` is a JSON object with [property settings](https://surveyjs.io/form-library/documentation/customize-question-types/add-custom-properties-to-a-form#survey-element-property-settings).

1. Add an editor for the custom property.           
Register the property editor in the `PropertyGridEditorCollection` and specify a standard JSON object that the custom type should produce. For instance, in this demo, the custom editor is a Dynamic Matrix. 

1. Define a survey JSON schema for the modal dialog.            
The modal dialog is built upon a regular SurveyJS survey. To specify the dialog's content, configure a survey JSON schema and use it to instantiate a [`SurveyModel`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model) object.

1. Add a button that opens the dialog to the editor title.          
Implement an [`onPropertyEditorUpdateTitleActions`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#onPropertyEditorUpdateTitleActions) event handler. Within it, check that the event is raised for a required property and add an [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) configuration object to the `options.titleActions` array. This configuration object should include the [`action`](https://surveyjs.io/form-library/documentation/api-reference/iaction#action) function.

1. Open the dialog on a button click.         
Call the global `showDialog` method within the `action` function to open the custom dialog when users click the button. Use the method's parameters to specify a `SurveyModel` instance that represents the dialog's content and define handling functions for the Apply and Cancel buttons. When a user clicks Apply, retrieve values from the pop-up survey using its `data` property and assign them to the current question. Refer to the code listing for details.

## Files

### `src/app/components/creator.component.css`

```css
.sv-property-editor .sd-root-modern {
    min-width: 640px;
}
```

### `src/app/components/creator.component.html`

```html
<div style="position: fixed; top: 0; bottom: 0; right: 0; left: 0;">
    <survey-creator [model]="model"></survey-creator>
</div>
```

### `src/app/components/creator.component.ts`

```ts
import { Component, OnInit, ViewEncapsulation } from "@angular/core";
import { SurveyCreatorModel } from "survey-creator-core";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { SurveyModel, Serializer, settings } from "survey-core";
import { PropertyGridEditorCollection, getLocaleStrings } from "survey-creator-core";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

// Step 1: Add a custom property to a question type
Serializer.addProperty("question", {
  name: "accessRules",
  type: "accessrules",
  category: "accessRules",
  showValueInLink: false
});

// Step 2: Add an editor for the custom property
PropertyGridEditorCollection.register({
  fit: (prop) => prop.type === "accessrules",
  getJSON: () => {
    return {
      "type": "matrixdynamic",
      "rowCount": 0,
      "allowRemoveRows": false,
      "columns": [
        {
          "name": "userRole",
          "title": "User Role",
          "cellType": "dropdown",
          "readOnly": true,
          "isRequired": true,
          "choices": [
            { "value": "admin", "text": "Admin" },
            { "value": "editor", "text": "Editor" },
            { "value": "viewer", "text": "Viewer" },
            { "value": "guest", "text": "Guest" }
          ]
        },
        {
          "name": "permissions",
          "title": "Permissions",
          "cellType": "dropdown",
          "readOnly": true,
          "choices": [
            { "value": "view", "text": "View" },
            { "value": "edit", "text": "Edit" }
          ],
          "showNoneItem": true,
          "noneText": "No access"
        }
      ]
    }
  }
});

const translation = getLocaleStrings("en");
translation.pe.tabs.accessRules = "Access Rules";
translation.pehelp.accessRules = "Specify user roles that can interact with the selected form element and define their permissions.";

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey-creator",
    templateUrl: "./creator.component.html",
    styleUrls: ["./creator.component.css"],
    encapsulation: ViewEncapsulation.None
})
export class SurveyCreatorComponent implements OnInit {
    model: SurveyCreatorModel;
    ngOnInit() {
        const creator = new SurveyCreatorModel();
        // Step 3: Define a survey JSON schema for the modal dialog
        const popupJson = {
          "elements": [
            {
              "type": "matrixdynamic",
              "name": "accessRules",
              "titleLocation": "hidden",
              "columns": [
                {
                  "name": "userRole",
                  "title": "User Role",
                  "isRequired": true,
                  "cellType": "dropdown",
                  "isUnique": true,
                  "choices": [
                    { "value": "admin", "text": "Admin" },
                    { "value": "editor", "text": "Editor" },
                    { "value": "viewer", "text": "Viewer" },
                    { "value": "guest", "text": "Guest" }
                  ]
                },
                {
                  "name": "permissions",
                  "title": "Permissions",
                  "cellType": "dropdown",
                  "defaultValue": "Edit",
                  "choices": [
                    { "value": "view", "text": "View" },
                    { "value": "edit", "text": "Edit" }
                  ],
                  "showNoneItem": true,
                  "noneText": "No access"
                }
              ],
              "rowCount": 0,
              "maxRowCount": 4,
              "addRowText": "Add Access Rule"
            }
          ],
          "showNavigationButtons": false
        };
        
        const popupSurvey = new SurveyModel(popupJson);
        
        // Step 4: Add a button that opens the dialog to the editor title
        creator.onPropertyEditorUpdateTitleActions.add((_, options) => {
          if (options.property.name === "accessRules") {
            popupSurvey.setValue("accessRules", options.element.accessRules);
            options.titleActions.push({
              id: "setAccessRules",
              title: "Set Access Rules",
              // Step 5: Open the dialog on a button click
              action: () => {
                settings.showDialog({
                  componentName: "survey",
                  data: { model: popupSurvey },
                  onApply: () => {
                    const validAccessRules = popupSurvey.validate();
                    if (validAccessRules) {
                      // Get values from the pop-up survey using its `data` property
                      // and update the current question (`options.element`)
                      options.element.setPropertyValue("accessRules", popupSurvey.data["accessRules"]);
                      return true;
                    }
                    return false;
                  },
                  onCancel: () => {
                    console.log("Cancel");
                  },
                  cssClass: "sv-property-editor",
                  title: "Configure Access Rules for " + options.element.title,
                  displayMode: "popup"
                }, creator.rootElement)
              }
            });
          }
        });
        
        creator.JSON = {
          "pages": [
            {
              "name": "page1",
              "elements": [
                {
                  "type": "text",
                  "name": "userName",
                  "title": "User Name",
                  "accessRules": [
                    { "userRole": "admin", "permissions": "edit" },
                    { "userRole": "viewer", "permissions": "view" },
                    { "userRole": "guest", "permissions": "none" }
                  ]
                },
                {
                  "type": "text",
                  "name": "dob",
                  "title": "Date of Birth",
                  "maskType": "datetime",
                  "maskSettings": {
                    "pattern": "m-dd-yyyy"
                  }
                }
              ]
            }
          ]
        }
        
        creator.showSidebar = true;
        creator.selectedElement = creator.survey.getQuestionByName("userName");
        creator.expandPropertyGridCategory("accessRules");
        this.model = creator;
    }
}
```

### `src/app/app.component.html`

```html
<component-survey-creator></component-survey-creator>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html"
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";
import { AppComponent } from "./app.component";
import { SurveyCreatorModule } from "survey-creator-angular";
import { SurveyCreatorComponent } from "./components/creator.component";

@NgModule({
    declarations: [AppComponent, SurveyCreatorComponent],
    imports: [BrowserModule, SurveyCreatorModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add global styles to this file and import other style files */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css"  ],
      "scripts": [  ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-angular-ui": "latest",
    "survey-creator-core": "latest",
    "survey-core": "latest",
    "survey-creator-angular": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular-devkit/build-angular": "~13.0.0",
    "@angular/cli": "~13.0.0",
    "@types/jasmine": "3.6.3",
    "@types/jasminewd2": "2.0.8",
    "@types/node": "14.14.28",
    "codelyzer": "6.0.1",
    "jasmine-core": "3.6.0",
    "jasmine-spec-reporter": "6.0.0",
    "karma": "6.1.1",
    "karma-chrome-launcher": "3.1.0",
    "karma-coverage-istanbul-reporter": "3.0.3",
    "karma-jasmine": "4.0.1",
    "karma-jasmine-html-reporter": "1.5.4",
    "protractor": "7.0.0",
    "ts-node": "9.1.1",
    "tslint": "~6.1.3",
    "typescript": "4.1.5"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/add-modal-property-editor-to-property-grid/vanillajs.md)
